//Constants
var IMAGES_FOLDER = "images/";
var IMAGES_EXTENSION = ".png";
var SKYPE_ACTIVEX = "Skype4COM.Skype.1";
var BATCH_PATH = "Skype4COM/RegS4C.bat";

var TAB_COUNT = 4;
var TAB_NAME = "Tab";
var TABPANEL_NAME = "TabPanel";
var TAB_NORMAL_SUFFIX = "N";
var TAB_SELECTED_SUFFIX = "S";

var ATTACHEMENT_SUCCESSS = "Success";

var ONLINESTS_UNKNOWN = "Unknown";
var ONLINESTS_OFFLINE = "Offline";

var ATTACHMENT_STATUS_TIMEOUT = 100;
var USER_STATUS_TIMEOUT = 10000;
var CONTACT_LIST_TIMEOUT = 10000;

//Variables
var SkypeObject; //Skype4COM instance
var WrapperOK; //Status of wrapper. True/False
var CommunicationOK; //The gadget established comunication with Skype

var SelectedContactHandle = "";

function Init() {
    //System.Gadget.settingsUI = "settings.html";
    CreateSkypeObject();
    MonitorSkypeStatus();
    MonitorUserStatus();
    MonitorContactList();
}

//Create Skype ActiveX Object
function CreateSkypeObject() {
    try {
        SkypeObject = new ActiveXObject(SKYPE_ACTIVEX);
        WrapperOK = true;
    }
    catch (e) {
        document.location.href = BATCH_PATH;
        WrapperOK = false;
        CreateSkypeObject();
    }
}

//Tab button click
function TabClick(index) {
    var i;
    var newSrc;
    for (i = 0; i < TAB_COUNT; i++) {
        newSrc = IMAGES_FOLDER + TAB_NAME + i + (index == i ? TAB_SELECTED_SUFFIX : TAB_NORMAL_SUFFIX) + IMAGES_EXTENSION;
        ChangePicture(TAB_NAME + i, newSrc);
        ShowHideElement(TABPANEL_NAME + i, index == i);
    }
}

function MonitorSkypeStatus() {
    var attachmentSts = SkypeObject.AttachmentStatus;
    var attachmentText = SkypeObject.Convert.AttachmentStatusToText(attachmentSts);
    if (attachmentText != ATTACHEMENT_SUCCESSS) {
        CommunicationOK = false;
        ShowSplash(true);
        if (SkypeObject.Client.IsRunning) {
            try {
                SkypeObject.Attach();
                CommunicationOK = true;
                ShowSplash(false);
            }
            catch (e) {
                //Do nothing
            }
        }
    }
    setTimeout("MonitorSkypeStatus()", ATTACHMENT_STATUS_TIMEOUT);
}

function MonitorUserStatus() {
    if (CommunicationOK) {
        var userHandler = SkypeObject.CurrentUserHandle;
        var userStatus = SkypeObject.CurrentUserStatus;
        var userStatusText = SkypeObject.Convert.OnlineStatusToText(userStatus);
        var headerMessage = userHandler + " - " + userStatusText;
        document.getElementById("HeaderImage").setAttribute("alt", headerMessage);
        document.getElementById("HeaderText").setAttribute("title", headerMessage);
    }
    setTimeout("MonitorUserStatus()", USER_STATUS_TIMEOUT);
}

function MonitorContactList() {
    RefreshContactList();
    setTimeout("MonitorContactList()", CONTACT_LIST_TIMEOUT);
}

function RefreshContactList() {
    if (CommunicationOK) {
        var i;
        var contactList = new Array();
        for (i = 1; i <= SkypeObject.Friends.Count; i++) {
            var contact = SkypeObject.Friends(i);
            if (CanAddContact(contact)) {
                contactList.push(contact);
            }
        }
        contactList.sort(ContactComparer);
        document.getElementById("Contacts").innerHTML = ConstructHTMLContactList(contactList);
    }
}

function ConstructHTMLContactList(contacts) {
    var HTMLCode = "";
    var i = 0;
    for (i = 0; i < contacts.length; i++) {
        var contact = contacts[i];
        var contactStatusImagePath = "\"images/Status" + contact.OnlineStatus + ".png\""
        var contactStatusImageHTML = "<img width=16 height=16 src=" + contactStatusImagePath + " />";
        var contactNameHTML = "<span>" + GetContactDisplayName(contact) + "</span>";
        if (contact.Handle != SelectedContactHandle) {
            HTMLCode += "<div onclick=ContactClick(\"" + contact.Handle + "\")>" + contactStatusImageHTML + contactNameHTML + "</div><br />";
        }
        else {
            HTMLCode += "<div class=\"SelectedContact\"><div class=\"SelectedContactHeader\">" + contactStatusImageHTML + contactNameHTML +
                "</div><br /><div id=\"ContactTools\"><img alt=\"Start Call\" onclick=CallStart() width=16 height=16 src=\"images/CallStart.png\">&nbsp;<img alt=\"Start Chat\" onclick=ChatStart() width=16 height=16 src=\"images/ChatStart.png\"></div></div><br /><br />";
        }
    }
    return HTMLCode;
}

function CallStart() {
    if (CommunicationOK) {
        if (SelectedContactHandle != "") {
            SkypeObject.PlaceCall(SelectedContactHandle);
            SkypeObject.Client.Minimize();
        }
   }
}

function ChatStart() {
    if (CommunicationOK) {
        if (SelectedContactHandle != "")
            SkypeObject.CreateChatWith(SelectedContactHandle).OpenWindow();
    }
}

function ContactClick(handle) {
    SelectedContactHandle = handle;
    RefreshContactList();
}

function CanAddContact(contact) {
    return true;
}

function ContactComparer(contact1, contact2) {

    var name1 = GetContactDisplayName(contact1);
    var name2 = GetContactDisplayName(contact2);
    var onlineStatus1 = SkypeObject.Convert.OnlineStatusToText(contact1.OnlineStatus);
    var onlineStatus2 = SkypeObject.Convert.OnlineStatusToText(contact2.OnlineStatus);
    var priorityValue1 = 0;
    var priorityValue2 = 0;
    priorityValue1 += (onlineStatus1 != ONLINESTS_UNKNOWN && onlineStatus1 != ONLINESTS_OFFLINE) ? 1 : 0;
    priorityValue2 += (onlineStatus2 != ONLINESTS_UNKNOWN && onlineStatus2 != ONLINESTS_OFFLINE) ? 1 : 0;
    if (priorityValue1 < priorityValue2)
        return 1;
    if (priorityValue1 > priorityValue2)
        return -1;
    if (name1 > name2)
        return 1;
    if (name1 < name2)
        return -1;
    return 0;
}

function GetContactDisplayName(contact) {
    var TextToBeDisplayed = contact.DisplayName;
    if (TextToBeDisplayed == "") TextToBeDisplayed = contact.FullName;
    if (TextToBeDisplayed == "") TextToBeDisplayed = contact.Handle;
    return TextToBeDisplayed;
}

function ShowSplash(show) {
    ShowHideElement("Splash", show);
    ShowHideElement("SkypeGadget", !show);
    if (show)
        TabClick(-1);
}

function ShowHideElement(elementName, show) {
    document.getElementById(elementName).style.visibility = (show == true ? "visible" : "hidden");
}

function ChangePicture(elementName, newSrc) {
    document.getElementById(elementName).src = newSrc;
}

function OpenSkype() {
    SkypeObject.Client.Start();
}

function AddContact() {
    if (CommunicationOK) {
        SkypeObject.Client.OpenAddContactDialog();
    }
}

function StartConference() {
    if (CommunicationOK) {
        SkypeObject.Client.OpenConferenceDialog();
    }
}